﻿Module Module1

    Structure Student

        <VBFixedString(20)> Public Name As String
        Dim ID As Integer
        Dim [Class] As Integer
        Public Age As Integer
        Private X As Integer

        Public Shared Count As Integer

        Shared Sub New()
            Count += 1
        End Sub

        Sub New(ByVal ID As Integer)
            Me.ID = ID
            Count += 1
        End Sub

        Shared Sub ShowCount()
            Console.WriteLine(Count)
        End Sub


        Public Shared Operator =(ByVal Std1 As Student, ByVal Std2 As Student) As Boolean
            If Std1.Name = Std2.Name _
                AndAlso Std1.ID = Std2.ID Then Return True
            Return False
        End Operator

        Public Shared Operator <>(ByVal Std1 As Student, ByVal Std2 As Student) As Boolean
            Return Not (Std1 = Std2)
        End Operator

        Sub Print()
            Console.WriteLine("Name: " & Name)
            Console.WriteLine("ID: " & ID)
            Console.WriteLine("Age: " & Age)
            Console.WriteLine("Class: " & Me.Class)
        End Sub

        Shared Sub PrintStudent(ByVal Std As Student)
            Console.WriteLine("ID: " & Std.ID)
            Console.WriteLine("Name: " & Std.Name)
            Console.WriteLine("Age: " & Std.Age)
            Console.WriteLine("Class: " & Std.Class)
        End Sub

        Function GetNextStudent() As Student
            Dim S As New Student
            S.ID = ID + 1 : Return S
        End Function

    End Structure

    Dim Students(3) As Student

    Sub FillStudentsData()
        With Students(0)
            .Name = "Ahmad" : .ID = 3 : .Class = 5
        End With

        With Students(1)
            .Name = "Ali" : .ID = 1 : .Class = 4
        End With

        With Students(2)
            .Name = "Hany" : .ID = 2 : .Class = 5
        End With

        With Students(3)
            .Name = "Kareem" : .ID = 4 : .Class = 5
        End With

    End Sub

    Function FindStudent(ByVal ID As Integer) As Student
        For I As Integer = 0 To UBound(Students)
            If Students(I).ID = ID Then Return Students(I)
        Next
        ' لو وصل التنفيذ إلى هنا، فهذا معناه عدم العثور على الطالب
        Return Nothing
    End Function

    Function GetStudentsInClass(ByVal SClass As Integer) As Student()
        Dim L As Integer = UBound(Students)
        Dim S(L) As Student, J As Integer = -1
        For I As Integer = 0 To L
            If Students(I).Class = SClass Then
                J += 1
                S(J) = Students(I)
            End If
        Next
        If J = -1 Then Return Nothing ' لم نعثر على طلاب
        If J < L Then ReDim Preserve S(J)
        Return S
    End Function

    Sub PrintStudentInfo(ByRef Std As Student)
        Console.WriteLine(Std.Name)
        Console.WriteLine(Std.Class)
        Console.WriteLine(Std.ID)
    End Sub

    Sub PrintStudentsInfo(ByRef Std() As Student)
        If Std Is Nothing Then Exit Sub
        For I As Integer = 0 To UBound(Std)
            Console.WriteLine(Std(I).Name)
            Console.WriteLine(Std(I).Class)
            Console.WriteLine(Std(I).ID)
        Next I
    End Sub

    Sub Main()
        Dim Std1 As Student
        Std1.Name = "Ahmad Shaker"
        Std1.ID = 40
        Std1.Class = 5
        Console.WriteLine(Std1.Name & ", ID: " & _
                     Trim(Std1.ID) & ", Class: " & Trim(Std1.Class))

        Dim Std2 As Student
        Std2.Name = "Mahmood Hoseen"
        Std2.ID = 12
        Std2.Class = 6
        Console.WriteLine(Std2.Name & ", ID: " & _
                    Trim(Std2.ID) & ", Class: " & Trim(Std2.Class))

        Dim Std As Student
        With Std
            .Name = "Ahmad"
            .ID = 3
            .Class = 5
        End With
        Console.WriteLine("Structure Length = " & Len(Std)) ' 32

        ' نسخ السجلات قيمي وليس مرجعيا
        Std2 = Std1 ' Ahmad Shaker
        Console.WriteLine(Std2.Name)

        Std2.Name = "Hany Said"
        Console.WriteLine(Std1.Name) ' Ahmad Shaker
        Console.WriteLine(Std2.Name) ' Hany Said

        If Std1.Name = Std2.Name And Std1.ID = Std2.ID And Std1.Class = Std2.Class Then
            Console.WriteLine("Std1 = Std2")
        Else
            Console.WriteLine("Std1 <> Std2")
        End If

        If Std1.Equals(Std2) Then
            Console.WriteLine("Std1 = Std2")
        Else
            Console.WriteLine("Std1 <> Std2")
        End If

        Std2.Name = Std1.Name

        If Std1 = Std2 Then
            Console.WriteLine("Std1 = Std2")
        Else
            Console.WriteLine("Std1 <> Std2")
        End If

        If Std1 <> Std2 Then
            Console.WriteLine("Std1 <> Std2")
        Else
            Console.WriteLine("Std1 = Std2")
        End If

        Dim Students(9) As Student
        Students(0).Name = "Ahmad" : Students(1).ID = 5
        If Students(3).Equals(Students(4)) Then
            Console.WriteLine("Std3 = Std4")
        End If
        If Students(3) = Students(4) Then
            Console.WriteLine("Std3 = Std4")
        End If

        ' البحث عن طالب بمعرفة رقمه
        FillStudentsData()
        Console.WriteLine("Enter Student ID")
        Dim ID As Integer = Val(Console.ReadLine())
        Std = FindStudent(ID)
        If Std = Nothing Then
            Console.WriteLine("Not Found")
        Else
            Console.WriteLine(Std.Name)
        End If

        Console.WriteLine("Students In 5th Class are: ")
        Dim Stds() As Student = GetStudentsInClass(5)
        If Stds Is Nothing Then
            Console.WriteLine("Not Found")
        Else
            For I As Integer = 0 To UBound(Stds)
                PrintStudentInfo(Stds(I))
            Next
        End If

        FindStudent(2).Print()

        Console.WriteLine()
        Console.WriteLine("Students In 5th Class are: ")
        PrintStudentsInfo(GetStudentsInClass(5))

        Console.WriteLine("2nd Student Info: ")
        FindStudent(2).Print()

        Console.WriteLine()
        Console.WriteLine("Next Student Info: ")
        FindStudent(2).GetNextStudent.Print()

        Std1.Count = 1
        Std2.Count = 2
        Console.WriteLine("Students Count = " & Std1.Count) ' 2

        Student.Count = 3
        Console.WriteLine("Students Count = " & Std1.Count)  ' 3

        Student.ShowCount()  ' 3
        Student.Count += 1
        Std1.ShowCount()  ' 4

        Student.PrintStudent(Std1)

        Student.Count = 0
        ' حدث الإنشاء المشترك يستدعى مرة واحدة فقط لهذا سيظل عدد التلاميذ صفرا مهما عرفت تلاميذ جددا
        Dim Std3 As New Student
        Student.ShowCount()  ' 0

        Dim Std4 As New Student(15)
        Student.ShowCount() '1
        Dim Std5 As New Student(8)
        Student.ShowCount() '2

        Console.ReadLine()
    End Sub
End Module
