﻿Module Module1

    Function MakeDir(ByVal Path As String) As Boolean
        On Error Resume Next
        Err.Clear() ' محو أي خطأ قديم
        MkDir(Path) ' محاولة إنشاء المجلد
        ' التأكد من عدم حدوث خطأ بسبب السطر السابق
        If Err.Number = 0 Then Return True
    End Function

    Function RemoveDir(ByVal Path As String) As String
        Try
            SetAttr(Path, FileAttribute.Normal)
            RmDir(Path)
        Catch ex As Exception
            Return ex.Message
        End Try
        Return ""
    End Function

    Function CurDrive() As String
        Dim X As String = CurDir()
        Return Mid(X, 1, 3)
    End Function

    Function PathExists(ByVal Path As String) As Boolean
        Try
            GetAttr(Path)
        Catch ex As Exception
            If ex.Message Like "*not found*" Then Return False
        End Try
        Return True
    End Function

    Function GetDrives() As Char()
        Dim Drives(23) As Char
        Dim C As Integer = -1

        For I As Integer = Asc("C"c) To Asc("Z"c)
            Try
                GetAttr(Chr(I) + ":\")
                C += 1
                Drives(C) = Chr(I)
            Catch

            End Try
        Next
        ReDim Preserve Drives(C)
        Return Drives
    End Function

    Function GetDirs(ByVal Path As String, Optional ByVal Attr As FileAttribute = -1) As String()
        Path = Replace(Path, "/", "\")
        If Not Path Like "*\" Then Path += "\"

        If Attr = -1 Then ' لم يرسل المستخدم المعامل الثاني 
            ' السمة الوحيدة التي نريدها هي أن يكون هذا العنصر مجلدا
            Attr = vbDirectory
        Else ' سنضيف سمة المجلد إلى السمات المطلوبة
            Attr = Attr Or vbDirectory
        End If

        Dim L As Integer = 255
        Dim Dirs(L) As String
        Dim C As Integer = -1

        Dim DirName As String = Dir(Path, vbDirectory)
        While DirName <> ""
            ' يجب تكوين المسار الكامل
            DirName = Path + DirName
            If (GetAttr(DirName) And Attr) = Attr Then
                C += 1
                If C > L Then
                    L += 255
                    ReDim Preserve Dirs(L)
                End If
                Dirs(C) = DirName
            End If
            DirName = Dir()
        End While
        ReDim Preserve Dirs(C)
        Return Dirs
    End Function

    Sub Main()
        If MakeDir("C:\Dir1") Then
            Console.WriteLine("Dir Created")
        Else
            Console.WriteLine("Sorry, Can't make the dir")
        End If

        If RemoveDir("C:\Dir1") = "" Then
            Console.WriteLine("Dir Deleted")
        Else
            Console.WriteLine("Can Not Delete The Dir")
        End If
        Console.WriteLine("Cur Drive: " & CurDrive())
        Console.WriteLine("Cur Dir: " & CurDir())

        If Not PathExists("C:\Dir1") Then
            Console.WriteLine("Can't Find The Dir")
        End If

        Console.WriteLine("Your Drives Are: ")
        Dim X() As Char = GetDrives()
        For I As Integer = 0 To UBound(X)
            Console.WriteLine(X(I))
        Next

        If PathExists("C:\Windows") Then
            Dim Fa As FileAttribute = GetAttr("C:\Windows")
            If (Fa And vbReadOnly) = vbReadOnly _
                OrElse (Fa And vbHidden) = vbHidden Then
                Console.WriteLine("Normal or Hidden")
            End If
        End If

        Console.WriteLine("Hidden Directories in C:\")
        Dim F() As String = GetDirs("c:\", FileAttribute.Hidden)
        For I As Integer = 0 To UBound(F)
            Console.WriteLine(F(I))
        Next


        Console.ReadLine()
    End Sub

End Module
