﻿Module Module1

    Function GetFiles(ByVal Path As String, _
               Optional ByVal Attr As FileAttribute = 47) As String()
        Path = Replace(Path, "/", "\")
        If Not Path Like "*\" Then Path += "\"
        Attr = Attr And 47
        Dim L As Integer = 255
        Dim Files(L) As String
        Dim C As Integer = -1

        Dim FileName As String = Dir(Path, Attr)
        While FileName <> ""
            FileName = Path + FileName
            If (GetAttr(FileName) And vbDirectory) = 0 Then
                C += 1
                If C > L Then
                    L += 255
                    ReDim Preserve Files(L)
                End If
                Files(C) = FileName
            End If
            FileName = Dir()
        End While
        ReDim Preserve Files(C)
        Return Files
    End Function

    Function GetDirContents(ByVal Path As String, Optional ByVal Attr As FileAttribute = 63) As String()
        Path = Replace(Path, "/", "\")
        If Not Path Like "*\" Then Path += "\"

        ' سنضيف سمة المجلد إلى السمات المطلوبة
        Attr = Attr Or vbDirectory

        Dim L As Integer = 255
        Dim Dirs(L) As String
        Dim C As Integer = -1

        Dim ContentName As String = Dir(Path, Attr)
        While ContentName <> ""
            C += 1
            If C > L Then
                L += 255
                ReDim Preserve Dirs(L)
            End If
            Dirs(C) = ContentName
            ContentName = Dir()
        End While
        ReDim Preserve Dirs(C)
        Return Dirs
    End Function

    Sub PrintFiles(ByVal Path As String)
        Static Level As Integer = 0
        Level += 1 ' زيادة المستوى
        ' حساب المسافات البادئة
        Dim Spaces = StrDup(2 * Level, " ")
        ' الحصول على ملفات المجلد الحالي
        Dim Files() As String = GetFiles(Path)
        ' كتابة أسماء ملفات المجلد الحالي
        For I As Integer = 0 To UBound(Files)
            Console.WriteLine(Spaces & Files(I))
        Next
        ' الحصول على مجلدات المجلد الحالي
        Dim Dirs() As String = GetDirs(Path)
        ' كتابة أسماء مجلدات المجلد الحالي
        For I As Integer = 0 To UBound(Dirs)
            Dim D As String = Dirs(I)
            Console.WriteLine(Spaces & "- " & D)
            ' طباعة كل مجلد فرعي باستدعاء الإجراء لنفسه
            PrintFiles(D)
        Next
        Level -= 1      ' إنقاص المستوى
    End Sub

    Sub PrintFiles2(ByVal Path As String)
        Static Level As Integer = 0
        ' لا تنس زيادة المستوى
        Level += 1
        ' حساب المسافات البادئة
        Dim Spaces = StrDup(2 * Level, " ")
        ' الحصول على محتويات المجلد الحالي
        Dim Contents() As String = GetDirContents(Path)
        ' كتابة أسماء مجلدات وملفات المجلد الحالي
        For I As Integer = 0 To UBound(Contents)
            Dim FullName As String
            If Path Like "*\" Then
                FullName = Path & Contents(I)
            Else
                FullName = Path & "\" & Contents(I)
            End If
            If (GetAttr(FullName) And vbDirectory) = 0 Then
                ' هذا العنصر ملف
                Console.WriteLine(Spaces & Contents(I))
            Else ' هذا العنصر مجلد
                Console.WriteLine(Spaces & "- " & Contents(I))
                ' طباعة كل مجلد فرعي باستدعاء الإجراء لنفسه
                PrintFiles(FullName)
            End If
        Next
        ' لا تنسَ إنقاص المستوى
        Level -= 1
    End Sub


    Function GetDirs(ByVal Path As String, Optional ByVal Attr As FileAttribute = -1) As String()
        Path = Replace(Path, "/", "\")
        If Not Path Like "*\" Then Path += "\"

        If Attr = -1 Then ' لم يرسل المستخدم المعامل الثاني 
            ' السمة الوحيدة التي نريدها هي أن يكون هذا العنصر مجلدا
            Attr = vbDirectory
        Else ' سنضيف سمة المجلد إلى السمات المطلوبة
            Attr = Attr Or vbDirectory
        End If

        Dim L As Integer = 255
        Dim Dirs(L) As String
        Dim C As Integer = -1

        Dim DirName As String = Dir(Path, vbDirectory)
        While DirName <> ""
            ' يجب تكوين المسار الكامل
            DirName = Path + DirName
            If (GetAttr(DirName) And Attr) = Attr Then
                C += 1
                If C > L Then
                    L += 255
                    ReDim Preserve Dirs(L)
                End If
                Dirs(C) = DirName
            End If
            DirName = Dir()
        End While
        ReDim Preserve Dirs(C)
        Return Dirs
    End Function

    Function GetDirSize(ByVal Path As String) As Long
        Dim FullName As String, DirSize As Long = 0
        Try
            Dim Contents() As String = GetDirContents(Path)
            For I As Integer = 0 To UBound(Contents)
                If Path Like "*\" Then
                    FullName = Path & Contents(I)
                Else
                    FullName = Path & "\" & Contents(I)
                End If
                If (GetAttr(FullName) And vbDirectory) = 0 Then
                    ' هذا العنصر ملف.. سنضيف حجمه إلى حجم المجلد
                    DirSize += FileLen(FullName)
                Else ' هذا العنصر مجلد
                    ' سنضيف حجمه إلى حجم المجلد باستدعاء الدالة لنفسها
                    DirSize += GetDirSize(FullName)
                End If
            Next
        Catch Ex As Exception
            Return -1
        End Try
        Return DirSize
    End Function

    Delegate Function Action(ByVal Path As String) As String

    Function PathExists(ByVal Path As String) As Boolean
        Try
            GetAttr(Path)
        Catch ex As Exception
            If ex.Message Like "*not found*" Then Return False
        End Try
        Return True
    End Function

    Function ScanDir(ByVal Path As String, ByVal DirAction As Action, ByVal FileAction As Action) As String
        If Not PathExists(Path) Then Return "Path Not Found"
        Dim FullName As String
        Try
            Dim Contents() As String = GetDirContents(Path)
            If UBound(Contents) = 0 Then Return "Dir Is Empty"
            Dim ErrMsg As String
            For I As Integer = 0 To UBound(Contents)
                If Path Like "*\" Then
                    FullName = Path & Contents(I)
                Else
                    FullName = Path & "\" & Contents(I)
                End If

                If (GetAttr(FullName) And vbDirectory) = 0 Then
                    ' هذا العنصر ملف
                    If Not FileAction Is Nothing Then
                        ErrMsg = FileAction(FullName)
                        If ErrMsg <> "" Then Return ErrMsg
                    End If
                Else ' هذا العنصر مجلد
                    If Not DirAction Is Nothing Then
                        ErrMsg = DirAction(FullName)
                        If ErrMsg <> "" Then Return ErrMsg
                    End If

                    ErrMsg = ScanDir(FullName, DirAction, _
                                      FileAction)
                    If ErrMsg <> "" Then Return ErrMsg
                End If
            Next
        Catch Ex As Exception
            Return "Error In Path " & Path & " : " & Ex.Message
        End Try
        Return ""
    End Function

    Function PrintDir(ByVal Path As String) As String
        Try
            Dim Level As Integer
            Level = Len(Path) - Len(Replace(Path, "\", ""))
            Dim Spaces = StrDup(2 * Level, " ")
            Console.WriteLine(Spaces & "- " & Path)
            Return ""
        Catch Ex As Exception
            Return "Error In Dir " & Path & " : " & Ex.Message
        End Try
    End Function

    Function PrintFile(ByVal Path As String) As String
        Try
            Dim Level As Integer
            Level = Len(Path) - Len(Replace(Path, "\", ""))
            Dim Spaces = StrDup(2 * Level, " ")
            Console.WriteLine(Spaces & Path)
            Return ""
        Catch Ex As Exception
            Return "Error In File " & Path & " : " & Ex.Message
        End Try
    End Function

    Function DelDir(ByVal Path As String) As String
        Try
            SetAttr(Path, FileAttribute.Normal)
            RmDir(Path)
            Return ""
        Catch Ex As Exception
            Return "Error In Dir " & Path & " : " & Ex.Message
        End Try
    End Function

    Function DelFile(ByVal Path As String) As String
        Try
            SetAttr(Path, FileAttribute.Normal)
            Kill(Path)
            Return ""
        Catch Ex As Exception
            Return "Error In File " & Path & " : " & Ex.Message
        End Try
    End Function

    Function ScanDir2(ByVal Path As String, ByVal DirAction As  _
                       Action, ByVal FileAction As Action, Optional ByVal ParentFirst _
                       As Boolean = True) As String

        If Not PathExists(Path) Then Return "Path Not Found"
        Dim FullName As String
        Try
            Dim Contents() As String = GetDirContents(Path)
            If UBound(Contents) = 0 Then Return "Dir Is Empty"
            Dim ErrMsg As String
            For I As Integer = 0 To UBound(Contents)
                If Path Like "*\" Then
                    FullName = Path & Contents(I)
                Else
                    FullName = Path & "\" & Contents(I)
                End If

                If (GetAttr(FullName) And vbDirectory) = 0 Then
                    ' هذا العنصر ملف
                    If Not FileAction Is Nothing Then
                        ErrMsg = FileAction(FullName)
                        If ErrMsg <> "" Then Return ErrMsg
                    End If
                Else ' هذا العنصر مجلد
                    If ParentFirst AndAlso Not DirAction Is Nothing Then
                        ErrMsg = DirAction(FullName)
                        If ErrMsg <> "" Then Return ErrMsg
                    End If
                    ErrMsg = ScanDir2(FullName, DirAction, FileAction, ParentFirst)
                    If ErrMsg <> "" Then Return ErrMsg

                    If ParentFirst = False AndAlso _
                            Not DirAction Is Nothing Then
                        ErrMsg = DirAction(FullName)
                        If ErrMsg <> "" Then Return ErrMsg
                    End If
                End If

            Next
        Catch Ex As Exception
            Return "Error In Path " & Path & " : " & Ex.Message
        End Try
        Return ""
    End Function

    Function DeleteDir(ByVal Path As String) As String
        'حذف محاويات المجلد 
        Dim X As String = ScanDir2(Path, AddressOf DelDir, AddressOf DelFile, False)
        If X <> "" Then Return ("Error: " & X)
        ' حذف المجلد نفسه
        Return DelDir(Path)
    End Function

    Sub Main()
        Dim X() As String = GetFiles("c:\", FileAttribute.Hidden)
        For I As Integer = 0 To UBound(X)
            Console.WriteLine(X(I))
        Next

        Console.WriteLine("************")
        Dim Msg As String = ScanDir("C:\Windows\temp", AddressOf PrintDir, AddressOf PrintFile)
        If Msg <> "" Then Console.WriteLine("Error: " & Msg)

        ' اختر مجلدا لا يهمك وجرب حذفه
        'Msg = ScanDir("Dir", Nothing, AddressOf DelFile)
        'If Msg <> "" Then Console.WriteLine("Error: " & Msg)


        Console.WriteLine("Wait to Calculate Size of c:")
        Dim Sz As Double = GetDirSize("C:\") / 1024 / 1024 / 1024
        Console.WriteLine("Size of C = " & Sz & " Gega")


        ' اختر مجلدا صغير المحتويات من جهازك لتجربة الكود التالي
        Dim Path = "C:\Program Files\Common Files\Microsoft Shared"
        'PrintFiles(Path)
        ' PrintFiles2(Path)

        Console.ReadLine()

    End Sub

End Module
