﻿Module Module1



    ''' <summary>
    ''' سجل المنبه
    ''' يستخدم لإطلاق رنة تنبيه في الوقت الذي يريده المستخدم
    ''' </summary>
    ''' <remarks>هذا المنبه يصلح للعمل 
    ''' في تطبيقات الاختبار ونماذج الويندوز</remarks>
    Public Structure Clock
        Event Ring(ByVal Time As Date)
        Delegate Sub AllowStopHandler(ByRef Sender As Clock, ByRef StopClock As Boolean)
        Event AllowStop As AllowStopHandler

        ''' <summary>
        ''' تعيد الوقت الحالي
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        ReadOnly Property Time() As Date
            Get
                Return Now
            End Get
        End Property

        Private pRingTime As Date
        ''' <summary>
        ''' تقرأ أو تغير وقت الرنين
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Property RingTime() As Date
            Get
                Return pRingTime
            End Get
            Set(ByVal value As Date)
                pRingTime = value
            End Set
        End Property

        Private pEnabled As Boolean
        ''' <summary>
        ''' تفعل أو تعطل المنبه
        ''' <value>إذا جعلتها<c>True</c>يتم تفعيل المنبه، وإذا جعلتها <c>False</c>يتم تعطيله</value>
        ''' </summary>
        Property Enabled() As Boolean
            Get
                Return pEnabled
            End Get
            Set(ByVal value As Boolean)
                pEnabled = value
                If pEnabled Then Start()
            End Set
        End Property

        ''' <summary>
        ''' يقوم بتشغيل المنبه
        ''' </summary>
        ''' <remarks></remarks>
        Sub Start()
            pEnabled = True
            Do
                If DateDiff(DateInterval.Second, pRingTime, Now) = 0 Then
                    RaiseEvent Ring(Now)
                    pEnabled = False
                    Exit Sub
                End If
                ' إيقاف المنبه إذا طلب المستخدم ذلك
                Dim StopClock As Boolean = False
                RaiseEvent AllowStop(Me, StopClock)
                If StopClock OrElse pEnabled = False Then
                    pEnabled = False
                    Exit Sub
                End If
            Loop
        End Sub

        ''' <summary>
        ''' يقوم بإيقاف المنبه عن العمل
        ''' </summary>
        ''' <remarks></remarks>
        Sub [Stop]()
            pEnabled = False
        End Sub
    End Structure

End Module
