﻿Class BitArray
    Dim Bits As Byte
    Sub New()
        Bits = 0
    End Sub

    Sub New(ByVal Bits As Byte)
        Me.Bits = Bits
    End Sub

    Sub New(ByVal Bits As String)
        Dim Ex As String
        Ex = "أقصى عدد مسموح به يتكون من 8 خانات ثنائية فقط"
        If Len(Bits) > 8 Then Throw New Exception(Ex)
        Bits = StrReverse(Bits)
        Dim B As String
        For I As Integer = 1 To Len(Bits)
            B = Mid(Bits, I, 1)
            If Not IsNumeric(B) OrElse B > 1 Then
                Ex = "الخانة الثنائية تقبل فقط القيمتين 0 و 1"
                Throw New Exception(Ex)
            End If
            Me(I - 1) = CByte(B)
        Next
    End Sub

    Default Property Bit(ByVal Index As Byte) As Byte
        Get
            If (Bits And 2 ^ Index) = 0 Then
                Return 0
            Else
                Return 1
            End If
        End Get

        Set(ByVal value As Byte)
            If value = 0 Then
                Bits = Bits And Not (2 ^ Index)
            Else
                Bits = Bits Or (2 ^ Index)
            End If
        End Set
    End Property

    Function ToByte() As Byte
        Return Bits
    End Function

    Overrides Function ToString() As String
        Dim S As String
        For I As Integer = 7 To 0 Step -1
            S += CStr(Me(I))
        Next
        Return S
    End Function

    Public Shared Widening Operator CType(ByVal B _
                As BitArray) As Byte
        Return B.Bits
    End Operator

    Public Shared Widening Operator CType(ByVal B As Byte) _
                As BitArray
        Return New BitArray(B)
    End Operator
    
    Public Shared Widening Operator CType(ByVal B As  _
            BitArray) As String
        Return B.ToString
    End Operator

    Public Shared Widening Operator CType(ByVal S _
                As String) As BitArray
        Return New BitArray(S)
    End Operator
End Class
