﻿Module StackApplications

    Sub ReverseArray(ByRef A() As String)
        Dim S As New Stack(Of String)
        For I As Integer = 0 To UBound(A)
            S.Push(A(I))
        Next
        For I As Integer = 0 To UBound(A)
            A(I) = S.Pop()
        Next
    End Sub

    Structure DirData
        Public Path As String
        Public Contents() As String
        Public Index As String
    End Structure

    Function ScanDirWithStack(ByVal Path As String) As String
        Dim FullName, ErrMsg As String, CurDir As New DirData
        Dim DirStack As New Stack(Of DirData)
        CurDir.Path = Path
        CurDir.Contents = Directory.GetDirContents(CurDir.Path)
LineStart:
        Try
            Do While CurDir.Index <= UBound(CurDir.Contents)
                If CurDir.Path Like "*\" Then
                    FullName = CurDir.Path & _
                                         CurDir.Contents(CurDir.Index)
                Else
                    FullName = CurDir.Path & "\" & _
                                         CurDir.Contents(CurDir.Index)
                End If

                If (GetAttr(FullName) And vbDirectory) = 0 Then
                    ' هذا العنصر ملف
                    ErrMsg = PrintName(FullName)
                    If ErrMsg <> "" Then Return ErrMsg
                Else ' هذا العنصر مجلد
                    ErrMsg = PrintName(FullName, "-")
                    If ErrMsg <> "" Then Return ErrMsg

                    ' كود مكافئ لاستدعاء الدالة لنفسها
                    DirStack.Push(CurDir)
                    'CurDir = New DirData تحتاج هذه الجملة إذا كنت تحفظ البيانات في فئة لا سجل
                    CurDir.Path = FullName
                    CurDir.Contents = Directory.GetDirContents(CurDir.Path)
                    CurDir.Index = 0
                    GoTo LineStart
                End If
                CurDir.Index += 1
            Loop
            ' كود مكافئ للعودة إلى الدالة التي استدعت لنفسها
            If Not DirStack.IsEmpty Then
                CurDir = DirStack.Pop()
                CurDir.Index += 1
                GoTo LineStart
            End If
        Catch Ex As Exception
            Return "Error In Path " & Path & " : " & Ex.Message
        End Try
        Return ""
    End Function

    Function PrintName(ByVal Path As String, Optional ByVal Sep As String = "") As String
        Try
            Dim Level As Integer
            Level = Len(Path) - Len(Replace(Path, "\", ""))
            Dim Spaces = StrDup(2 * Level, " ")
            Form1.TxtTest.AppendText(Spaces & Sep & Path & vbCrLf)
            Return ""
        Catch Ex As Exception
            Return "Error In Dir " & Path & " : " & Ex.Message
        End Try
    End Function

End Module
