﻿Module Calculator

    Function ParseTree(ByRef Tokens As LinkedList(Of String)) As Double
        Dim CurTree, NewTree As Tree(Of String)
        Dim Token As String
        If Tokens.MoveFirst Then
            Do
                Token = Tokens.CurItem
                NewTree = New Tree(Of String)
                NewTree.Value = Token
                Select Case Token
                    Case "+", "-"
                        GoUp(CurTree)
                        NewTree.AddNode(CurTree)
                        CurTree = NewTree
                    Case "*", "×", "/", "÷"
                        If CurTree.Nodes.Count > 0 Then
                            CurTree = CurTree.Nodes(1)
                        End If
                        CurTree.AddNode(NewTree)
                        Dim Tmp As String = CurTree.Value
                        CurTree.Value = NewTree.Value
                        NewTree.Value = Tmp
                    Case Else
                        If CurTree Is Nothing Then
                            CurTree = NewTree
                        Else
                            CurTree.AddNode(NewTree)
                        End If
                End Select
            Loop While Tokens.MoveNext
            GoUp(CurTree)
            Return CurTree.Value
        End If
    End Function

    Sub GoUp(ByRef CurTree As Tree(Of String))
        Do
            If CurTree.Nodes.Count > 1 Then
                CurTree.Value = ComputeCurTree(CurTree)
            End If
            If CurTree.Parent Is Nothing Then Exit Sub
            CurTree = CurTree.Parent
        Loop
    End Sub

    Function ComputeCurTree(ByRef T As Tree(Of String)) As Double
        Dim L As Double = T.Nodes(0).Value
        Dim R As Double = T.Nodes(1).Value
        T.Nodes.Clear()
        Select Case T.Value
            Case "+"
                Return L + R
            Case "-"
                Return L - R
            Case "*", "×"
                Return L * R
            Case "/", "÷"
                Return L / R
        End Select
    End Function

    Function GetTokens(ByVal S As String) As LinkedList(Of String)
        S = S.Replace(" ", "")
        Dim Tokens As New LinkedList(Of String)
        Dim LastPos As Integer, Token As String
        For Pos As Integer = 1 To Len(S)
            Token = Mid(S, Pos, 1)
            If Not IsNumeric(Token) Then
                If Pos - LastPos > 1 Then
                    Tokens.Add(Mid(S, LastPos + 1, Pos - LastPos - 1))
                End If
                Tokens.Add(Token)
                LastPos = Pos
            End If
        Next
        If LastPos < Len(S) Then
            Tokens.Add(Mid(S, LastPos + 1, Len(S) - LastPos))
        End If
        Return Tokens
    End Function
    
    Function FullParseTree(ByRef Tokens As LinkedList(Of String)) As Double
        Dim CurTree, NewTree As Tree(Of String)
        Dim Token As String
        Do While Tokens.Count > 0
            Token = Tokens(0)
            Tokens.RemoveAt(0)
            NewTree = New Tree(Of String)
            NewTree.Value = Token
            Select Case Token
                Case "("
                    NewTree.Value = FullParseTree(Tokens)
                    If CurTree Is Nothing Then
                        CurTree = NewTree
                    Else
                        CurTree.AddNode(NewTree)
                    End If
                Case ")"
                    ' لن ننهي الدالة مباشرة، لأننا نحسب قيمتها
                    '  بعد الخروج من الجملة التكرارية 
                    Exit Do
                Case "+", "-"
                    GoUp(CurTree)
                    NewTree.AddNode(CurTree)
                    CurTree = NewTree
                Case "*", "×", "/", "÷"
                    If CurTree.Nodes.Count > 0 Then
                        CurTree = CurTree.Nodes(1)
                    End If
                    CurTree.AddNode(NewTree)
                    Dim Tmp As String = CurTree.Value
                    CurTree.Value = NewTree.Value
                    NewTree.Value = Tmp
                Case Else
                    If CurTree Is Nothing Then
                        CurTree = NewTree
                    Else
                        CurTree.AddNode(NewTree)
                    End If
            End Select
        Loop

        GoUp(CurTree)
        Return CurTree.Value
    End Function


End Module
