﻿Class Queue(Of QType)
    Dim QLen As Integer
    Dim Q() As QType
    Dim St As Integer = 0, En As Integer = -1

    Sub New()
        QLen = 50
        ReDim Q(QLen - 1)
    End Sub

    Sub New(ByVal MaxLength As Integer)
        QLen = MaxLength
        ReDim Q(QLen - 1)
    End Sub

    ReadOnly Property Length() As Integer
        Get
            Return QLen
        End Get
    End Property
    Dim pIsEmpty As Boolean = True
    ReadOnly Property IsEmpty() As Boolean
        Get
            Return pIsEmpty
        End Get
    End Property

    Dim pIsFull As Boolean = False
    ReadOnly Property IsFull() As Boolean
        Get
            Return pIsFull
        End Get
    End Property

    Property Peek() As QType
        Get
            If pIsEmpty Then Throw New Exception("الطابور فارغ")
            Return Q(St)
        End Get

        Set(ByVal Value As QType)
            If pIsEmpty Then Throw New Exception("الطابور فارغ")
            Q(St) = Value
        End Set
    End Property

    Sub Enqueue(ByVal Item As QType)
        If pIsFull Then Throw New Exception("الطابور ممتلئ")
        En += 1
        If En >= QLen Then En = 0
        Q(En) = Item
        pIsFull = (St - En = 1) OrElse (En - St = QLen - 1)
        pIsEmpty = False
    End Sub

    Function Dequeue() As QType
        If pIsEmpty Then Throw New Exception("الطابور فارغ")
        Dequeue = Q(St) ' القيمة العائدة
        pIsFull = False
        If En = St Then
            pIsEmpty = True
            St = 0
            En = -1
        Else
            St += 1
            If St >= QLen Then St = 0
        End If
    End Function

    Function ToArray() As QType()
        If pIsEmpty Then Return Nothing
        Dim S() As QType
        If St <= En Then
            ReDim S(En - St)
            For I As Integer = St To En
                S(I - St) = Q(I)
            Next
            Return S
        Else
            ReDim S(QLen - St + En)
            For I As Integer = St To QLen - 1
                S(I - St) = Q(I)
            Next

            For I As Integer = 0 To En
                S(QLen - St + I) = Q(I)
            Next
            Return S
        End If
    End Function

    Sub Clear()
        pIsEmpty = True
        St = 0
        En = -1
    End Sub
End Class
