﻿Public Class UndoRedo(Of SType)
    Dim pUnDo As New Stack(Of SType)
    Dim pReDo As New Stack(Of SType)
    Public MaxUnDos As Integer = 100

    Public Event ButtonState(ByVal CanUnDo As Boolean, _
                ByVal CanReDo As Boolean)

    Sub New(ByVal MaxUnDos As Integer)
        Me.MaxUnDos = MaxUnDos
    End Sub

    Sub New(ByVal MaxUnDos As Integer, ByVal InitialState As SType)
        Me.MaxUnDos = MaxUnDos
        pUnDo.Push(InitialState)
    End Sub

    Function UnDo() As SType
        pReDo.Push(pUnDo.Pop)
        RaiseEvent ButtonState(pUnDo.Count > 1, _
                            pReDo.Count > 0)
        Return pUnDo.Peek
    End Function

    Function ReDo() As SType
        Dim R As SType = pReDo.Pop
        pUnDo.Push(R)
        RaiseEvent ButtonState(pUnDo.Count > 1, _
                            pReDo.Count > 0)
        Return R
    End Function

    Sub AdjustUnDo()
        If pReDo.Count = 0 Then Exit Sub
        Dim TmpStack As New Stack(Of SType)
        Dim ReDoPeek As SType
        Dim UnDoPeek As SType = pUnDo.Peek
        Do
            ReDoPeek = pReDo.Pop()
            pUnDo.Push(ReDoPeek)
            If pReDo.IsEmpty Then Exit Do
            TmpStack.Push(ReDoPeek)
        Loop

        Do Until TmpStack.IsEmpty
            pUnDo.Push(TmpStack.Pop)
        Loop

        pReDo.Clear()
        pUnDo.Push(UnDoPeek)
    End Sub

    Sub ReportChanges(ByVal LastState As SType)
        AdjustUnDo()
        pUnDo.Push(LastState)
        If pUnDo.Count > MaxUnDos + 1 Then
            pUnDo.DropBottom()
        End If
        RaiseEvent ButtonState(pUnDo.Count > 1, _
                  pReDo.Count > 0)
    End Sub

    Sub ClearReDo()
        AdjustUnDo()
        RaiseEvent ButtonState(pUnDo.Count > 1, _
                  pReDo.Count > 0)
    End Sub
End Class
