﻿Module DrowBmp

    Structure Header
        Dim Type As Short
        Dim Size As Integer
        Dim Reserved As Integer
        Dim Offset As Integer
    End Structure

    Structure InfoHeader
        Dim Size As Integer
        Dim Width, Height As Integer
        Dim Planes As Short
        Dim Bits As Short
        Dim Compression As Integer
        Dim ImageSize As Integer
        Dim XResolution, YResolution As Integer
        Dim NColours As Integer
        Dim ImportantColours As Integer
    End Structure


    Sub DrowX(ByVal FileName As String, ByVal ImgWidth As Integer, ByVal ImgHight As Integer,
              Optional ByVal ForeGround() As Byte = Nothing, Optional ByVal BackGround() As Byte = Nothing)
        Dim L As Integer = ImgHight - 1
        Dim W As Integer = ImgWidth - 1
        If ForeGround Is Nothing Then ForeGround = New Byte() {0, 0, 0} ' أسود
        If BackGround Is Nothing Then BackGround = New Byte() {255, 255, 255} ' أبيض

        ' حساب الوحدات الزائدة في نهاية كل صف
        Dim RowEnd() As Byte
        Dim PadZeros As Integer = 4 - (3 * ImgWidth) Mod 4
        If PadZeros = 4 Then
            PadZeros = 0
        ElseIf PadZeros > 0 Then
            ReDim RowEnd(PadZeros - 1)
        End If
        Dim ImgSize As Integer
        ImgSize = (ImgWidth * ImgHight * 3) + (PadZeros * ImgHight)
        Dim No As Integer = FreeFile()

        Try
            FileOpen(No, FileName, OpenMode.Binary)
            ' كتابة الرأس الأول
            Dim H As Header
            H.Type = Asc("B") + Asc("M") * 256
            H.Size = 14 + 40 + ImgSize : H.Offset = 14 + 40
            FilePut(No, H)
            ' كتابة الرأس الثاني
            Dim IH As InfoHeader
            IH.Size = 40 : IH.Width = ImgWidth : IH.Height = ImgHight
            IH.Planes = 1 : IH.Bits = 24 : IH.ImageSize = ImgSize
            IH.NColours = 0
            FilePut(No, IH)
            ' كتابة النقاط
            For Y As Integer = 0 To ImgHight - 1
                Dim Y1 As Integer = Int(Y * W / L)
                For X As Integer = 0 To ImgWidth - 1
                    If X = Y1 OrElse X + Y1 = W Then
                        FilePut(No, ForeGround)
                    Else : FilePut(No, BackGround)
                    End If
                Next
                ' إضافة الوحدات الزائدة قبل الانتقال إلى الصف التالي
                If PadZeros > 0 Then FilePut(No, RowEnd)
            Next
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            FileClose(No)
        End Try

    End Sub

    Sub InvertColors(ByVal FileName As String)
        Dim No As Integer = FreeFile()
        Try
            FileOpen(No, FileName, OpenMode.Binary)
            ' قراءة الرأس
            Dim H As Header
            FileGet(No, H)
            If H.Type <> Asc("B") + Asc("M") * 256 Then
                MsgBox("هذا ليس ملف صورة نقطية")
                Exit Sub
            End If
            ' قراءة البيانات
            Seek(No, H.Offset + 1)
            Dim B(LOF(No) - H.Offset - 1) As Byte
            FileGet(No, B)
            For I As Integer = 0 To UBound(B)
                B(I) = 255 - B(I)
            Next
            ' كتابة البيانات
            Seek(No, H.Offset + 1)
            FilePut(No, B)
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            FileClose(No)
        End Try
    End Sub

    Sub InvertColors2(ByVal FileName As String)
        Dim No As Integer = FreeFile()
        Try
            FileOpen(No, FileName, OpenMode.Binary)
            Dim H As Header
            FileGet(No, H)
            If H.Type <> Asc("B") + Asc("M") * 256 Then
                MsgBox("هذا الملف ليس صورة نقطية")
                Exit Sub
            End If

            Dim IH As InfoHeader
            FileGet(No, IH)

            Dim PadZeros As Integer = IH.Width Mod 4
            Dim Z() As Byte
            If PadZeros > 0 Then ReDim Z(PadZeros - 1)
            Dim B(3 * IH.Width - 1) As Byte

            Do Until EOF(No)
                ' قراءة صف وعكس ألوانه
                FileGet(No, B)
                For I As Integer = 0 To UBound(B)
                    B(I) = 255 - B(I)
                Next
                ' الرجوع إلى بداية الصف لكتابة التغييرات في الملف
                Seek(No, Seek(No) - 3 * IH.Width)
                FilePut(No, B)
                ' قراءة الوحدات الزائدة في نهاية الصف وإهمالها
                If PadZeros > 0 Then FileGet(No, Z)
            Loop
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            FileClose(No)
        End Try

    End Sub
End Module
