﻿Imports Vb = Microsoft.VisualBasic

Public Class StreamReader
    Inherits TextReader
    Dim pFileName As String
    Dim No As Integer = FreeFile()

    Public Sub New(ByVal FileName As String, Optional ByVal _
                Share As OpenShare = OpenShare.LockWrite)
        pFileName = FileName
        FileOpen(No, FileName, OpenMode.Input, OpenAccess.Read, Share)
    End Sub

    Public Overrides Sub Close()
        FileClose(No)
    End Sub

    Public Overrides Function ReadChar() As Char
        Dim C As Char
        Input(No, C)
        Return C
    End Function

    Public Overrides Function ReadString(ByVal Count As Integer) As String
        If Position >= Length Then Return ""
        If Position + Count > Length Then
            Count = Length - Position
        End If
        Dim X As String = InputString(No, Count)
        If Len(X) < Count Then
            X = X + StrDup(Count - Len(X), Chr(0))
        End If
        Return X
    End Function

    Public Overrides Function Seek(ByVal Offset As Long, _
                  Optional ByVal origin As SeekOrigin = SeekOrigin.Current) As Long
        Dim Pos As Long
        Select Case origin
            Case SeekOrigin.Begin
                Pos = Offset
            Case SeekOrigin.Current
                Pos = VB.Seek(No) + Offset - 1
            Case Else 'SeekOrigin.End 
                Pos = LOF(No) - 1 + Offset
        End Select
        If Pos >= LOF(No) OrElse Pos < 0 Then
            Throw New Exception("لا يمكن الانتقال إلى هذا الموضع")
        End If
        VB.Seek(No, Pos + 1)
        Return Pos
    End Function

    Public Overrides ReadOnly Property Length() As Long
        Get
            Return LOF(No)
        End Get
    End Property

    Public Overrides Property Position() As Long
        Get
            Return VB.Seek(No) - 1
        End Get
        Set(ByVal Pos As Long)
            If Pos >= LOF(No) OrElse Pos < 0 Then
                Throw New Exception("لا يمكن الانتقال إلى هذا الموضع")
            End If
            VB.Seek(No, Pos + 1)
        End Set
    End Property

    ReadOnly Property FileName() As String
        Get
            Return pFileName
        End Get
    End Property

    Public Sub Lock()
        Vb.Lock(No)
    End Sub

    Public Sub Unlock()
        Vb.Unlock(No)
    End Sub

    Function GetFileOpenAttr() As OpenMode
        Return FileAttr(No)
    End Function
End Class
