﻿Imports Vb = Microsoft.VisualBasic

Public MustInherit Class TextWriter

    Protected pFormat As String
    Sub New()
        MyBase.New()
    End Sub

    Sub New(ByVal Format As String)
        pFormat = Format
    End Sub

    Property Format() As String
        Get
            Return pFormat
        End Get
        Set(ByVal value As String)
            pFormat = value
        End Set
    End Property

    Protected Function ApplayFormat(ByVal Str As String) _
                      As String
        If pFormat = "" Then Return Str
        If IsNumeric(Str) Then
            Return Vb.Format(Val(Str), pFormat)
        ElseIf IsDate(Str) Then
            Return Vb.Format(CDate(Str), pFormat)
        End If
        Return Str
    End Function

    Dim pNewLine As String = vbCrLf
    Public Property NewLine() As String
        Get
            Return pNewLine
        End Get
        Set(ByVal value As String)
            pNewLine = value
        End Set
    End Property
    Public MustOverride Sub WriteString(ByRef Value _
                As String)

    Public Sub WriteLine(ByRef Line As String)
        If Position = 0 Then
            WriteString(Line)
        Else
            WriteString(NewLine + Line)
        End If
    End Sub

    Public Sub Write(ByRef Data() As String, _
                Optional ByVal Sep As String = "", _
                Optional ByVal St As Integer = 0, _
                Optional ByVal Count As Integer = 1)
        For I As Integer = St To St + Count - 1
            WriteString(Data(I) & Sep)
        Next
    End Sub

    Public Sub WriteNumbers(ByVal Num As Byte)
        WriteString(Chr(Num))
    End Sub

    Public Sub WriteNumbers(ByVal Num As Integer)
        Dim B() As Byte = BitConverter.GetBytes(Num)
        Dim Str As String
        Str = System.Text.Encoding.ASCII.GetString(B)
        WriteString(Str)
    End Sub

    Enum SeekOrigin
        Begin = 0
        Current = 1
        [End] = 2
    End Enum

    Public MustOverride Function Seek(ByVal St As Long, _
                Optional ByVal origin As SeekOrigin = SeekOrigin.Current) As Long
    Public MustOverride ReadOnly Property Length() As Long
    Public MustOverride Property Position() As Long
    Public MustOverride Sub Close()
End Class
