﻿Imports Vb = Microsoft.VisualBasic

Public Class StreamWriter : Inherits TextWriter
    Dim pFileName As String

    Function FileExists(ByVal FileName As String) As Boolean
        Try
            Dim L As Long = FileLen(FileName)
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Enum FileMode
        Append
        Create
        CreateNew
        Open
        OpenOrCreate
        Truncate
    End Enum

    Private Sub CheckFile(ByVal mode As FileMode)
        Dim Exists As Boolean = FileExists(pFileName)
        Select Case mode
            Case FileMode.CreateNew
                If Exists Then
                    Throw New Exception("الملف موجود بالفعل")
                End If
            Case FileMode.Create, FileMode.Truncate
                ' محو محتويات الملف بمحو الملف نفسه
                Kill(pFileName)
            Case FileMode.Open
                If Not Exists Then
                    Throw New Exception("الملف غير موجود")
                End If
        End Select
    End Sub

    Dim No As Integer = FreeFile()
    Public Sub New(ByVal FileName As String, Optional ByVal _
                mode As FileMode = FileMode.OpenOrCreate, _
                Optional ByVal share As OpenShare = OpenShare.LockWrite)
        pFileName = FileName
        CheckFile(mode)
        If FileMode.Append Then
            FileOpen(No, FileName, OpenMode.Append, OpenAccess.Write, share)
        Else
            FileOpen(No, FileName, OpenMode.Output,OpenAccess.Write, share)
        End If
    End Sub

    Public Overrides Sub Close()
        FileClose(No)
    End Sub

    Public Overrides Sub WriteString(ByRef Str As String)
        Print(No, ApplayFormat(Str))
    End Sub

    Public Overrides Function Seek(ByVal Offset As Long, _
                    Optional ByVal origin As SeekOrigin = SeekOrigin.Current) As Long
        Dim Pos As Long
        Select Case origin
            Case SeekOrigin.Begin
                Pos = Offset
            Case SeekOrigin.Current
                Pos = VB.Seek(No) + Offset - 1
            Case Else 'SeekOrigin.End 
                Pos = LOF(No) - 1 + Offset
        End Select
        If Pos >= LOF(No) OrElse Pos < 0 Then
            Throw New Exception("لا يمكن الانتقال إلى هذا الموضع")
        End If
        VB.Seek(No, Pos + 1)
        Return Pos
    End Function
    
    Public Overrides ReadOnly Property Length() As Long
        Get
            Return LOF(No)
        End Get
    End Property

    Public Overrides Property Position() As Long
        Get
            Return VB.Seek(No) - 1
        End Get
        Set(ByVal Pos As Long)
            If Pos >= LOF(No) OrElse Pos < 0 Then
                Throw New Exception("لا يمكن الانتقال إلى هذا الموضع")
            End If
            VB.Seek(No, Pos + 1)
        End Set
    End Property

    ReadOnly Property FileName() As String
        Get
            Return pFileName
        End Get
    End Property

    Public Sub Lock()
        VB.Lock(No)
    End Sub
    Public Sub Unlock()
        VB.Unlock(No)
    End Sub
    Function GetFileOpenAttr() As OpenMode
        Return FileAttr(No)
    End Function
End Class
