﻿Imports Vb = Microsoft.VisualBasic

Public Class StringWriter
    Inherits TextWriter
    Dim S As String
    Dim pLength As Long
    Dim pPosition As Long

    Sub New(ByVal Str As String, Optional ByVal Frormat _
                    As String = "")
        pFormat = Frormat
        S = ApplayFormat(Str)
        pLength = Len(Str)
        pPosition = 0
    End Sub

    Public Overrides Sub Close()
        S = Nothing
    End Sub

    Private Function LStr(ByVal Length As Integer) As String
        If Length < 1 OrElse Length > pLength Then Return ""
        Return VB.Left(S, Length)
    End Function

    Private Function RStr(ByVal Length As Integer) As String
        If Length < 1 OrElse Length > pLength Then Return ""
        Return Vb.Right(S, Length)
    End Function

    Public Overrides Sub WriteString(ByRef value As String)
        Dim X As String = ApplayFormat(value)
        S = LStr(pPosition) + X + RStr(pLength - (pPosition + Len(value)))
        pPosition += Len(X)
    End Sub

    Public Overrides Function Seek(ByVal Offset As Long, _
                Optional ByVal origin As SeekOrigin = SeekOrigin.Current) As Long
        Dim Pos As Long
        Select Case origin
            Case SeekOrigin.Begin
                Pos = Offset
            Case SeekOrigin.Current
                Pos = pPosition + Offset
            Case Else 'SeekOrigin.End 
                Pos = pLength - 1 + Offset
        End Select
        If Pos >= pLength OrElse Pos < 0 Then Return -1
        pPosition = Pos
        Return Pos
    End Function

    Public Overrides ReadOnly Property Length() As Long
        Get
            Return pLength
        End Get
    End Property

    Public Overrides Property Position() As Long
        Get
            Return pPosition
        End Get
        Set(ByVal Pos As Long)
            If Pos >= pLength OrElse Pos < 0 Then
                Throw New Exception("لا يمكن الانتقال إلى هذا الموضع")
            End If
            pPosition = Pos
        End Set
    End Property

    ' سنستبدل هنا وسيلة التحويل إلى نص الموروثة من فئة الكائن
    Public Overrides Function ToString() As String
        Return S
    End Function

    Public Function ToArray() As Char()
        Return S.ToCharArray
    End Function
End Class
