﻿Module Bmp


    Structure Header
        Dim Type As Short
        Dim Size As Integer
        Dim Reserved As Integer
        Dim Offset As Integer
    End Structure

    Structure InfoHeader
        Dim Size As Integer
        Dim Width, Height As Integer
        Dim Planes As Short
        Dim Bits As Short
        Dim Compression As Integer
        Dim ImageSize As Integer
        Dim XResolution, YResolution As Integer
        Dim NColours As Integer
        Dim ImportantColours As Integer
    End Structure

    Sub DrowBWX(ByVal FileName As String, ByVal ImgWidth As Integer, ByVal ImgHight As Integer,
          Optional ByVal ForeGround() As Byte = Nothing, Optional ByVal BackGround() As Byte = Nothing)

        Dim L As Integer = ImgHight - 1
        Dim W As Integer = ImgWidth - 1
        ' حساب الوحدات الزائدة في نهاية كل صف
        Dim RowEnd() As Byte
        Dim WB As Single = ImgWidth / 8
        If WB <> Int(WB) Then WB = Int(WB) + 1
        Dim PadZeros As Integer = 4 - WB Mod 4
        If PadZeros = 4 Then PadZeros = 0
        If PadZeros > 0 Then ReDim RowEnd(PadZeros - 1)
        Dim ImgSize As Integer
        ImgSize = (WB * ImgHight) + (PadZeros * ImgHight)
        Dim Bmp As New FileStream(FileName)

        Dim H As Header
        H.Type = Asc("B") + Asc("M") * 256
        H.Offset = 14 + 40 + 2 * 4
        H.Size = H.Offset + ImgSize
        Bmp.WriteStruc(H)

        Dim IH As InfoHeader ' الرأس الثانئ
        IH.Size = 40
        IH.Width = ImgWidth
        IH.Height = ImgHight
        IH.Planes = 1
        IH.Bits = 1
        IH.ImageSize = ImgSize
        IH.NColours = 2
        Bmp.WriteStruc(IH)

        If ForeGround Is Nothing Then ForeGround = New Byte() {0, 0, 0, 0} ' أسود
        If BackGround Is Nothing Then BackGround = New Byte() {255, 255, 255, 0} ' أبيض

        ' قائمة الألوان (لونان فقط)
        Bmp.Write(ForeGround, 0, 4)
        Bmp.Write(BackGround, 0, 4)

        ' كتابة النقاط
        Dim BA As New BitArray(CByte(255))
        Dim I As Integer = 7
        For Y As Integer = 0 To ImgHight - 1
            Dim Y1 As Integer = Int(Y * W / L)
            For X As Integer = 0 To ImgWidth - 1
                If X = Y1 OrElse X + Y1 = W Then
                    BA(I) = 0
                Else
                    BA(I) = 1
                End If
                I -= 1
                If I = -1 Then
                    I = 7 : Bmp.WriteByte(BA)
                    BA = New BitArray(CByte(255))
                End If
            Next

            If I < 7 Then
                I = 7 : Bmp.WriteByte(BA)
                BA = New BitArray(CByte(255))
            End If
            If PadZeros > 0 Then Bmp.Write(RowEnd, 0, PadZeros)
        Next
        Bmp.Close()


    End Sub

    Sub DrowBWX2(ByVal FileName As String, ByVal ImgWidth As Integer, ByVal ImgHight As Integer,
      Optional ByVal ForeGround() As Byte = Nothing, Optional ByVal BackGround() As Byte = Nothing)

        Dim L As Integer = ImgHight - 1
        Dim W As Integer = ImgWidth - 1
        ' حساب الوحدات الزائدة في نهاية كل صف
        Dim RowEnd() As Byte
        Dim WB As Single = ImgWidth / 8
        If WB <> Int(WB) Then WB = Int(WB) + 1
        Dim PadZeros As Integer = 4 - WB Mod 4
        If PadZeros = 4 Then PadZeros = 0
        If PadZeros > 0 Then ReDim RowEnd(PadZeros - 1)
        Dim ImgSize As Integer
        ImgSize = (WB * ImgHight) + (PadZeros * ImgHight)
        Dim Bmp As New FileStream(FileName)

        Dim H As Header
        H.Type = Asc("B") + Asc("M") * 256
        H.Offset = 14 + 40 + 2 * 4
        H.Size = H.Offset + ImgSize
        Bmp.WriteStruc(H)

        Dim IH As InfoHeader ' الرأس الثانئ
        IH.Size = 40
        IH.Width = ImgWidth
        IH.Height = ImgHight
        IH.Planes = 1
        IH.Bits = 1
        IH.ImageSize = ImgSize
        IH.NColours = 2
        Bmp.WriteStruc(IH)

        If ForeGround Is Nothing Then ForeGround = New Byte() {0, 0, 0, 0} ' أسود
        If BackGround Is Nothing Then BackGround = New Byte() {255, 255, 255, 0} ' أبيض

        ' قائمة الألوان (لونان فقط)
        Bmp.Write(ForeGround, 0, 4)
        Bmp.Write(BackGround, 0, 4)

        ' كتابة النقاط
        Dim Buf As New BitBuffer(Bmp, CByte(255))
        For Y As Integer = 0 To ImgHight - 1
            Dim Y1 As Integer = Int(Y * W / L)
            For X As Integer = 0 To ImgWidth - 1
                If X = Y1 OrElse X + Y1 = W Then
                    Buf.Add(0)
                Else
                    Buf.Add(1)
                End If
            Next
            If Buf.Possition > 0 Then Buf.Flush()
            If PadZeros > 0 Then Bmp.Write(RowEnd, 0, PadZeros)
        Next
        Bmp.Close()



    End Sub

End Module
