﻿Imports Vb = Microsoft.VisualBasic

Public Class Form1

    Sub ShowResult(ByVal C As IEnumerable)
        TextBox1.Clear()
        For Each Elm In C
            TextBox1.AppendText(Elm & vbCrLf)
        Next
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim Cst = From C In Customers _
                  Select C.Name
        TextBox1.Clear()
        For Each Elm In Cst
            TextBox1.AppendText(Elm & vbCrLf)
        Next
    End Sub


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim Cst = From C In Customers
                          Where C.Age > 40
                          Select C.Name
        ShowResult(Cst)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim Cst = From C In Customers
                          Where C.Age > 40
                          Select C.Name, C.Age

        TextBox1.Clear()
        For Each C In Cst
            TextBox1.AppendText(C.Name & " " & C.Age & " عاما" & vbCrLf)
        Next

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim Cst = From C In Customers
                          Where C.Age < 40
                          Select C

        TextBox1.Clear()
        Dim IE = Cst.GetEnumerator
        While IE.MoveNext
            Dim C = IE.Current
            TextBox1.AppendText(C.Name & " " & C.Age & " " & C.City & vbCrLf)
        End While

    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim AllOrders = From Cst In Customers
        From ord In Cst.Orders
        Select ord

        TextBox1.Clear()
        TextBox1.AppendText("الرقم" & vbTab & "المنتج" & vbTab & "السعر" & vbTab & "الخصم" & vbCrLf)
        TextBox1.AppendText("----------------------------------------------" & vbCrLf)
        For Each O In AllOrders
            TextBox1.AppendText(O.ID & vbTab & O.Product & vbTab & O.Price & vbTab & (O.Discount * 100) & "%" & vbCrLf)
        Next
        TextBox1.SelectionStart = 1
        TextBox1.ScrollToCaret()
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim Result = From Cst In Customers, Std In Students _
                      Select Cst, Std

        ShowJoinedResult(Result)
    End Sub

    Sub ShowJoinedResult(ByVal Result As IEnumerable)
        TextBox1.Clear()
        TextBox1.AppendText("الزبون" & vbTab & "التلميذ" & vbCrLf)
        TextBox1.AppendText("-------------------" & vbCrLf)
        For Each I In Result
            TextBox1.AppendText(I.Cst.Name & vbTab & I.Std.Name & " من " & I.Std.City & vbCrLf)
        Next
        TextBox1.SelectionStart = 1
        TextBox1.ScrollToCaret()
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Dim result = From Cst In Customers, Std In Students
                               Select CustomerName = Cst.Name, StudentID = Std.ID

        TextBox1.Clear()
        TextBox1.AppendText("اسم الزبون" & vbTab & "رقم الطالب" & vbCrLf)
        TextBox1.AppendText("-------------------------------------" & vbCrLf)
        For Each I In result
            TextBox1.AppendText(I.CustomerName & vbTab & vbTab & I.StudentID & vbCrLf)
        Next
        TextBox1.SelectionStart = 1
        TextBox1.ScrollToCaret()
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        Dim Res = From Cst In Customers, ord In Cst.Orders
                   Select CustomerName = Cst.Name, ord.Price
                   Where Price > 500
                   Select CustomerName, Price

        TextBox1.Clear()
        For Each C In Res
            TextBox1.AppendText(C.CustomerName & " " & C.Price & vbCrLf)
        Next
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        Dim Res As IEnumerable(Of CstData) = From Cst In Customers, ord In Cst.Orders
                           Select CustomerName = Cst.Name, ord.Price
                           Where Price > 500
                           Select New CstData With {
                                     .Name = CustomerName, .Price = Price}

        TextBox1.Clear()
        For Each C In Res
            TextBox1.AppendText(C.Name & " " & C.Price & vbCrLf)
        Next
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        Dim City = "المنصورة"
        Dim Res = From Cst In Customers _
                          Where Cst.City = City
        ShowName(Res)
    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
        Dim Res = From Cst In Customers _
                  Where Vb.Left(Cst.Name, 1) = "م"

        ShowName(Res)
    End Sub

    Sub ShowName(ByVal Res As IEnumerable)
        TextBox1.Clear()
        For Each Elm In Res
            TextBox1.AppendText(Elm.Name & vbCrLf)
        Next
    End Sub

    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
        Dim Orders = From Cst In Customers
                  From Ord In Cst.Orders _
                   Let FinalPrice = Ord.Price * (1 - Ord.Discount)
                   Where FinalPrice < 300
                   Select Ord.Product, Ord.Price, FinalPrice


        TextBox1.Clear()
        TextBox1.AppendText("المنتج" & vbTab & "السعر" & vbTab & "السعر بعد الخصم" & vbCrLf)
        TextBox1.AppendText("----------------------------------------------" & vbCrLf)
        For Each O In Orders
            TextBox1.AppendText(O.Product & vbTab & O.Price & vbTab & vbTab & O.FinalPrice & vbCrLf)
        Next
        TextBox1.SelectionStart = 1
        TextBox1.ScrollToCaret()
    End Sub

    Private Sub Button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.Click
        Dim Res = From Std In Students _
                   Let Sucsess = Std.Grade >= 50,
                          Good = Std.Grade >= 65
                   Where Sucsess AndAlso Not Good
                   Select Std.Name

        ShowResult(Res)
    End Sub

    Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click
        Dim Res = From CSt In Customers
                   Skip 7
                   Select CSt.Name

        ShowResult(Res)
    End Sub

    Private Sub Button15_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.Click
        Dim A() As Integer = {1, 1, 2, 1, 3, 4, 3, 5, 2, 1, 3}
        Dim B = From I In A _
                Skip While I <= 4

        ShowResult(B)
    End Sub

    Private Sub Button16_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button16.Click
        Dim Res = From CSt In Customers
           Skip 4 Take 3
           Select CSt.Name

        ShowResult(Res)
    End Sub

    Private Sub Button17_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button17.Click
        Dim A() As Integer = {1, 1, 2, 1, 3, 4, 3, 5, 2, 1, 3}
        Dim B = From I In A
                Skip While I < 3
                Take While I < 5

        ShowResult(B)
    End Sub

    Private Sub Button18_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button18.Click
        Dim Res = From Std In Students _
                   Order By Std.Grade, Std.Name _
                   Select Std

        ShowStudents(Res)

    End Sub

    Sub ShowStudents(ByVal Res As IEnumerable)
        TextBox1.Clear()
        TextBox1.AppendText("الاسم" & vbTab & "الدرجة" & vbCrLf)
        TextBox1.AppendText("----------------------------------------------" & vbCrLf)
        For Each S In Res
            TextBox1.AppendText(S.Name & vbTab & S.Grade & vbCrLf)
        Next
        TextBox1.SelectionStart = 1
        TextBox1.ScrollToCaret()
    End Sub

    Private Sub Button19_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button19.Click, Button20.Click
        Dim A() As Integer = {10, 7, 8, 4, 6, 3, 5, 1}
        Dim B = From Num In A Order By Num

        ShowResult(B)
    End Sub

    Private Sub Button21_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button21.Click
        Dim A() As Integer = {10, 7, 8, 4, 6, 3, 5, 1}
        Dim B = From Num In A _
                       Order By (Num Mod 2), Num

        ShowResult(B)
    End Sub

    Private Sub Button22_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button22.Click, Button24.Click
        Dim A() As Integer = {1, 3, 3, 2, 4, 5, 7, 1, 3, 2}
        Dim B = From I In A
               Order By I Distinct

        ShowResult(B)
    End Sub

    Private Sub Button23_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button23.Click
        Dim Cities = From Cst In Customers
                   Select Cst.City Distinct

        ShowResult(Cities)
    End Sub

    Private Sub Button25_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button25.Click
        Dim Res = From Cst In Customers Join Std In Students
                   On Cst.Name Equals Std.Name

        ShowJoinedResult(Res)
    End Sub

    Private Sub Button26_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button26.Click
        Dim Res = From Cst In Customers
                   Group Join Std In Students _
                   On Cst.Name Equals Std.Name _
                   Into StdNames = Group

        TextBox1.Clear()
        For Each I In Res
            TextBox1.AppendText(I.Cst.Name & vbCrLf)
            For Each Std In I.StdNames
                TextBox1.AppendText(vbTab & Std.Name & " من " & Std.City & vbCrLf)
            Next
        Next


    End Sub

    Private Sub Button27_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button27.Click
        Dim StdGroup = From Cst In Customers
                                     Join Std In Students
                                     On Cst.Name Equals Std.Name
                                     Select Cst

        Dim Res = From Cst In StdGroup
                           Group Join Std In Students
                           On Cst.Name Equals Std.Name
                           Into AvgGrade = Average(Std.Grade)
                           Select Cst, AvgGrade Distinct

        TextBox1.Clear()
        For Each I In Res
            TextBox1.AppendText(I.Cst.Name & vbCrLf)
            TextBox1.AppendText("متوسط الدرجات = " & I.AvgGrade & vbCrLf)
        Next
    End Sub

    Private Sub Button28_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button28.Click
        Dim Res = From Cst In Customers
                          Order By Cst.Name
                          Group By CityName = Cst.City
                          Into CityCustomers = Group, Count()
                          Order By CityName

        TextBox1.Clear()
        For Each I In Res
            TextBox1.AppendText(I.CityName & " (" & I.Count & " من الزبائن)" & vbCrLf)
            For Each Customer In I.CityCustomers
                TextBox1.AppendText(vbTab & Customer.Name & vbCrLf)
            Next
        Next

    End Sub

    Private Sub Button29_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button29.Click
        Dim Res = From Cst In Customers
                  Order By Cst.City
                  Group By Cst.City, Cst.Age
                  Into CityCustomers = Group

        TextBox1.Clear()
        For Each I In Res
            TextBox1.AppendText(I.City & " (" & I.Age & " سنة)" & vbCrLf)
            For Each Customer In I.CityCustomers
                TextBox1.AppendText(vbTab & Customer.Name & vbCrLf)
            Next
        Next
    End Sub

    Private Sub Button30_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button30.Click
        Dim words() = {"Ab", "bd", "a", "abc", "b"}
        Dim Res = From Word In words
               Group UCase(Word) By Word.Length
               Into GroupedWords = Group
               Order By Length
               Select Length, GroupedWords

        TextBox1.Clear()
        For Each I In Res
            TextBox1.AppendText(I.Length & ":" & vbCrLf)
            For Each Word In I.GroupedWords
                TextBox1.AppendText(vbTab & Word & vbCrLf)
            Next
        Next
    End Sub

    Private Sub Button31_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button31.Click
        Dim A() As Integer = {1, 2, 3, 0}
        Dim S = Aggregate Num In A
                        Into Sum(Num)

        TextBox1.AppendText("مجموع العناصر = " & S & vbCrLf)  '6

        Dim Res = Aggregate Num In A _
                        Into Min(Num), Max(Num), Count()

        TextBox1.AppendText("أصغر عنصر هو: " & Res.Min & vbCrLf) ' 6
        TextBox1.AppendText("أكبر عنصر هو: " & Res.Max & vbCrLf) ' 3
        TextBox1.AppendText("عدد العناصر هو: " & Res.Count & vbCrLf) ' 4
    End Sub

    Private Sub Button32_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button32.Click
        Dim MaxOrders = From Cst In Customers
                       Aggregate Order In Cst.Orders
                       Into MaxOrder = Max(Order.Price)
                       Select MaxOrder

        ShowResult(MaxOrders)
    End Sub

    Private Sub Button33_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button33.Click
        Dim Orders = From Cst In Customers
                       Aggregate Order In Cst.Orders
                       Into MaxOrder = Max(Order.Price),
                       MinOrder = Min(Order.Price)

        ShowOrders(Orders)
    End Sub

    Sub ShowOrders(ByVal Orders As IEnumerable)
        TextBox1.Clear()
        TextBox1.AppendText("اسم الزبون" & vbTab & "ثمن أغلى طلب" & vbTab & "ثمن أرخص طلب" & vbCrLf)
        TextBox1.AppendText("------------------------------------------------------------------" & vbCrLf)
        For Each O In Orders
            TextBox1.AppendText(O.Cst.Name & vbTab & vbTab & O.MaxOrder & vbTab & vbTab & O.MinOrder & vbCrLf)
        Next
        TextBox1.SelectionStart = 0
        TextBox1.ScrollToCaret()
    End Sub

    Private Sub Button34_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button34.Click
        Dim Res = Aggregate Std In Students
                Into Count(Std.Grade < 50)

        MsgBox(Res)

    End Sub

    Private Sub Button35_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button35.Click
        Dim N() As Double = {1.9, 2, 8, 4, 5.7, 6, 7.2, 0}
        Dim Res = Aggregate num In N Into Median()
        MsgBox("Median =  " & Res)

        Dim I() As Integer = {1, 2, 3, 4, 5}
        Res = Aggregate num In I Into Median(num)
        MsgBox("Median =  " & Res)

    End Sub

    Private Sub Button36_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button36.Click
        Dim Orders = From Cst In Customers
                       Aggregate Order In Cst.Orders.AsParallel
                       Into MaxOrder = Max(Order.Price),
                       MinOrder = Min(Order.Price)

        ShowOrders(Orders)

    End Sub
End Class
