﻿Public Class MyComuter
    Private Declare Ansi Function SetSuspendState Lib _
              "powrprof" (ByVal Hibernate As Integer, ByVal _
              ForceCritical As Integer, ByVal DisableWakeEvent _
              As Integer) As Integer

    Shared Sub Sleep(ByVal Force As Boolean)
        If Force Then
            SetSuspendState(0, 1, 0)
        Else
            SetSuspendState(0, 0, 0)
        End If
    End Sub

    Shared Sub Hibernate(ByVal Force As Boolean)
        If Force Then
            SetSuspendState(1, 1, 0)
        Else
            SetSuspendState(1, 0, 0)
        End If
    End Sub

    Private Enum Options As Integer
        LogOff = 0
        ShutDown = 1
        Restart = 2
    End Enum

    Shared Sub LogOff(ByVal Force As Boolean)
        MyComuter.ExitWindows(Options.LogOff, Force)
    End Sub

    Shared Sub Restart(ByVal Force As Boolean)
        MyComuter.ExitWindows(Options.Restart, Force)
    End Sub

    Shared Sub ShutDown(ByVal Force As Boolean)
        MyComuter.ExitWindows(Options.ShutDown, Force)
    End Sub

    Private Declare Ansi Function ExitWindowsEx Lib _
              "user32" (ByVal uFlags As Integer, ByVal dwReserved As Integer) As Integer

    Private Shared Sub ExitWindows(ByVal Action As Integer, ByVal force As Boolean)
        EnableToken("SeShutdownPrivilege")
        If force Then Action = Action Or EWX_FORCE
        If ExitWindowsEx(Action, 0) = 0 Then
            Throw New Exception("Err")
        End If
    End Sub

    ' كل الكود التالي لإعطاء البرنامج صلاحية إغلاق الويندوز
    Private Structure LUID
        Public LowPart As Integer
        Public HighPart As Integer
    End Structure

    Private Structure LUID_AND_ATTRIBUTES
        Public pLuid As LUID
        Public Attributes As Integer
    End Structure

    Private Structure TOKEN_PRIVILEGES
        Public PrivilegeCount As Integer
        Public Privileges As LUID_AND_ATTRIBUTES
    End Structure

    Private Const TOKEN_ADJUST_PRIVILEGES As Integer = &H20
    Private Const TOKEN_QUERY As Integer = &H8
    Private Const SE_PRIVILEGE_ENABLED As Integer = &H2
    Private Const EWX_FORCE As Integer = 4
    Private Declare Ansi Function OpenProcessToken Lib _
                  "advapi32" (ByVal ProcessHandle As IntPtr, _
                   ByVal DesiredAccess As Integer, _
                   ByRef TokenHandle As IntPtr) As Integer
    Private Declare Ansi Function LookupPrivilegeValue Lib _
                 "advapi32" Alias "LookupPrivilegeValueA" _
                  (ByVal lpSystemName As String, ByVal lpName As _
                   String, ByRef lpLuid As LUID) As Integer
    Private Declare Ansi Function AdjustTokenPrivileges Lib _
                 "advapi32" (ByVal TokenHandle As IntPtr, ByVal _
                  DisableAllPrivileges As Integer, ByRef NewState _
                  As TOKEN_PRIVILEGES, ByVal BufferLength _
                  As Integer, ByRef PreviousState As  _
                  TOKEN_PRIVILEGES, ByRef ReturnLength As _
                  Integer) As Integer

    Private Shared Sub EnableToken(ByVal privilege As String)
        Dim tokenHandle As IntPtr
        Dim privilegeLUID As LUID
        Dim newPrivileges As TOKEN_PRIVILEGES
        Dim tokenPrivileges As TOKEN_PRIVILEGES
        If OpenProcessToken(Process.GetCurrentProcess.Handle, _
        TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, _
         tokenHandle) = 0 Then Throw New Exception("Err")
        If LookupPrivilegeValue("", privilege, privilegeLUID) = 0 Then Throw New Exception("Err")
        tokenPrivileges.PrivilegeCount = 1
        tokenPrivileges.Privileges.Attributes = SE_PRIVILEGE_ENABLED
        tokenPrivileges.Privileges.pLuid = privilegeLUID


        If AdjustTokenPrivileges(tokenHandle, 0, tokenPrivileges, 4 + (12 * tokenPrivileges.PrivilegeCount), _
               newPrivileges, 4 + (12 * newPrivileges.PrivilegeCount)) = 0 Then
            Throw New Exception("Err")
        End If
    End Sub
End Class
